'use strict';

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref2) {
  var t = _ref2.types;

  // some strange error occurs if I move this fn outside context
  // and then run babel-node with this plugin
  var localInteropRequire = function localInteropRequire(path) {
    var res = require((0, _path.resolve)(process.cwd(), path));
    if ('default' in res) {
      return res.default;
    }
    return res;
  };

  return {
    visitor: {
      CallExpression: function CallExpression(path, _ref3) {
        var filenameRelative = _ref3.file.opts.filenameRelative;
        var _ref3$opts = _ref3.opts;
        _ref3$opts = _ref3$opts === undefined ? {} : _ref3$opts;
        var _ref3$opts$config = _ref3$opts.config;
        var configPath = _ref3$opts$config === undefined ? './webpack.config.js' : _ref3$opts$config;
        var _ref3$opts$verbose = _ref3$opts.verbose;
        var verbose = _ref3$opts$verbose === undefined ? true : _ref3$opts$verbose;
        var _path$node = path.node;
        var calleeName = _path$node.callee.name;
        var args = _path$node.arguments;

        if (calleeName !== 'require' || !args.length || !t.isStringLiteral(args[0])) {
          return;
        }

        var config = localInteropRequire((0, _path.resolve)(process.cwd(), configPath));
        if (Object.keys(config).length === 0) {
          // it's possible require calls inside webpack config or bad config
          return;
        }

        // TODO add other webpack checks
        if (config.module.loaders.some(function (l) {
          return l.test.test(args[0].value);
        })) {
          var _args = _slicedToArray(args, 1);

          var filePath = _args[0].value;

          if (!t.isVariableDeclarator(path.parent)) {
            throw new Error('You can\'t import file ' + filePath + ' to a module scope.');
          }

          var fileAbsPath = (0, _path.resolve)(process.cwd(), (0, _path.dirname)(filenameRelative), filePath);
          var webPackResult = (0, _runWebPackSync2.default)({ path: fileAbsPath, configPath: configPath, config: config, verbose: verbose });

          var expr = processWebPackResult(webPackResult, config);
          path.replaceWith(expr);
        }
      }
    }
  };
};

var _path = require('path');

var _babylon = require('babylon');

var _babelTraverse = require('babel-traverse');

var _babelTraverse2 = _interopRequireDefault(_babelTraverse);

var _runWebPackSync = require('./runWebPackSync');

var _runWebPackSync2 = _interopRequireDefault(_runWebPackSync);

var _babelTypes = require('babel-types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var processWebPackResult = function processWebPackResult(webPackResult) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _ref$output = _ref.output;
  _ref$output = _ref$output === undefined ? {} : _ref$output;
  var _ref$output$publicPat = _ref$output.publicPath;
  var publicPath = _ref$output$publicPat === undefined ? '' : _ref$output$publicPat;

  var webpackResultAst = (0, _babylon.parse)(webPackResult);
  var expr = null;

  // without ExtractTextPlugin css-loader result looks like `blabla.locals = {...blbala}`
  (0, _babelTraverse2.default)(webpackResultAst, {
    FunctionExpression: function FunctionExpression(pathFn) {
      if (pathFn.node.params.length >= 2 && pathFn.node.params[1].name === 'exports') {
        pathFn.traverse({
          AssignmentExpression: function AssignmentExpression(path) {
            if (path.node.left.property && path.node.left.property.name === 'locals') {
              expr = path.node.right;
            }
          }
        });
      }
    }
  });

  // with ExtractTextPlugin css-loader result looks like `module.exports = {...blbala}`
  if (expr === null) {
    (0, _babelTraverse2.default)(webpackResultAst, {
      FunctionExpression: function FunctionExpression(pathFn) {
        if (pathFn.node.params.length >= 2 && pathFn.node.params[1].name === 'exports') {
          pathFn.traverse({
            AssignmentExpression: function AssignmentExpression(path) {
              if (path.node.left.property && path.node.left.property.name === 'exports') {
                expr = path.node.right;
              }
            },
            BinaryExpression: function BinaryExpression(pathBin) {
              pathBin.traverse({
                MemberExpression: function MemberExpression(pathM) {
                  if (pathM.node.object.name === '__webpack_require__' && pathM.node.property.name === 'p') {
                    pathM.replaceWith((0, _babelTypes.StringLiteral)(publicPath)); // eslint-disable-line
                  }
                }
              });
            }
          });
        }
      }
    });
  }

  return expr;
};